package com.zhongshu.reward.client.ret;

import lombok.Getter;

/**
 * 结果状态模板
 */
public enum ResultState {

    Success("成功"),
    Fail("失败"),
    Error("错误"),
    Exception("异常"),
    Robot("机器验证"),

    UserExit("用户存在"),
    UserNotExit("用户不存在"),
    UserOrPassWordError("用户名或密码错误"),

    NOT_TOKEN_ERROR("token获取失败"),
    NOT_AUTH_ERROR("需要授权"),
    EXPIRE_ERROR( "token已过期"),
    INVALID_TOKEN("无效token"),
    LOGIN_REQUIRED("需要登录"),
    CODE_ERROR("验证码错误"),

    AccountNotNull("账户不能为空"),
    AccountExists("用户存在"),
    AccountNotExists("账户不存在"),
    NOT_WECHAT_AUTH("用户微信未授权"),
    ;

    @Getter
    private String remark;

    ResultState(String remark) {
        this.remark = remark;
    }
}
