package com.zhongshu.reward.server.core.controller.wallet;

import com.github.microservice.auth.security.annotations.ResourceAuth;
import com.github.microservice.auth.security.type.AuthType;
import com.zhongshu.reward.client.model.param.TransferRulerParam;
import com.zhongshu.reward.server.core.service.TransferRulerService;
import io.swagger.annotations.Api;
import io.swagger.v3.oas.annotations.Operation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author wjf
 * @date 2024/8/12
 */
@Slf4j
@RestController
@RequestMapping("/transferRuler")
@Api(tags = "提现规则设置")
public class TransferRulerController {

    @Autowired
    TransferRulerService transferRulerService;

    @Operation(summary = "新增/修改提现规则", description = "新增/修改提现规则")
//    @ResourceAuth(value = "user", type = AuthType.User)
    @PostMapping("saveOrUpdate")
    public Object saveOrUpdate(@RequestBody TransferRulerParam param){
        return transferRulerService.saveOrUpdate(param);
    }

    @Operation(summary = "获取提现规则", description = "获取提现规则")
    @ResourceAuth(value = "user", type = AuthType.User)
    @GetMapping("getRuler")
    public Object getRuler(){
        return transferRulerService.getRuler();
    }
}
