package com.zhongshu.reward.server.core.domain;

import com.github.microservice.components.data.mongo.mongo.domain.SuperEntity;
import com.zhongshu.reward.client.type.ReceiptsStatus;
import com.zhongshu.reward.client.type.ReceiptsType;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.mongodb.core.mapping.DBRef;
import org.springframework.data.mongodb.core.mapping.Document;

import java.math.BigDecimal;

/**
 * 到账记录
 * @author wjf
 * @date 2024/8/5
 */
@Data
@Builder
@Document
@AllArgsConstructor
@NoArgsConstructor
public class WalletReceipts extends SuperEntity {

    /**
     * 钱包
     */
    @DBRef(lazy = true)
    private Wallet wallet;

    /**
     * 邀请人id
     */
    private String inviteUserId;

    /**
     * 被邀请人id
     */
    private String userId;

    /**
     * 预计到账时间
     */
    private Long estimatedTime;

    /**
     * 实际到账时间
     */
    private Long receiptsTime;

    /**
     * 到账类型
     */
    private ReceiptsType receiptsType;

    /**
     * 到账金额
     */
    private BigDecimal total = BigDecimal.ZERO;

    /**
     * 状态
     */
    private ReceiptsStatus status;

    /**
     * 外部订单号
     */
    private String outTradeNo;

    /**
     * 产生入账的订阅消息
     */
    private VipUserRecord vipUserRecord;
}
