package com.zhongshu.reward.server.core.domain;

import com.github.microservice.components.data.mongo.mongo.domain.SuperEntity;
import com.zhongshu.reward.client.type.TransferChannel;
import com.zhongshu.reward.client.type.TransferStatus;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.DBRef;
import org.springframework.data.mongodb.core.mapping.Document;

import java.math.BigDecimal;

/**
 * 提现记录
 * @author wjf
 * @date 2024/8/5
 */
@Data
@Builder
@Document
@AllArgsConstructor
@NoArgsConstructor
public class WxTransferBatch extends SuperEntity {

    /**
     * 内部批次单号
     */
    @Indexed(unique = true)
    private String batchNo;

    /**
     * (内部)提现明细单号
     */
    @Indexed
    private String detailNo;

    /**
     * 提现钱包
     */
    @DBRef(lazy = true)
    private Wallet wallet;

    /**
     * 提现金额
     */
    private BigDecimal total;

    /**
     * 提现渠道
     */
    @Indexed
    private TransferChannel channel;

    /**
     * 提现前账户信息
     */
    private Wallet beforeWalletInfo;

//    /**
//     * 到账时间
//     */
//    private Long tradeTime;

    /**
     * 订单状态
     */
    @Indexed
    private TransferStatus transferStatus;

    /**
     * 批次状态
     */
    @Indexed
    private String batchStatus;

    /**
     * 明细状态
     */
    @Indexed
    private String detailStatus;


    private String closeReason;

    /**
     * wx批次单号
     */
    @Indexed
    private String wxBatchId;

    /**
     * wx批次单号
     */
    @Indexed
    private String wxDetailId;

    /**
     * openid
     */
    private String openid;

    /**
     * 异常原因
     */
    private String failReason;
}
